% First section: obtain IC for differet value of k and c
close all
clear
Y=load('hennig.txt');
Y=Y(1:1200,:);
[n,v]=size(Y);
rng(980)
nsamp=1000;

% Computation of information criterion
out=tclustIC(Y,'cleanpool',false,'plots',0,'nsamp',nsamp);

%% second part
% Plot first 3 best solutions using as Information criterion MIXMIX
disp('Best 4 solutions using MIXMIX')
ThreshRandIndex=0.8;
NumberOfBestSolutions=7;
[outMIXMIX]=tclustICsol(out,'whichIC','MIXMIX','plots',0,'NumberOfBestSolutions',NumberOfBestSolutions,'ThreshRandIndex',ThreshRandIndex);

IDXMIX=out.IDXMIX;
cc=out.cc;
seqcc=1:length(cc);

%% Figure 10: 4 panels plots with the 4 best spurious or true solutions
Bestsols=outMIXMIX.MIXMIXbs;
typesolution='spurious';
typesolution='true';
close all
ij=0;
FontSize=14;
Typesolution='Solution ';
for i=1:NumberOfBestSolutions
    if ij==4
        break
    end
    if strcmp(Bestsols{i,5},typesolution)
        ij=ij+1;
        subplot(2,2,ij)
        idxsel=IDXMIX{Bestsols{i,1},seqcc(cc==Bestsols{i,2})};
        gscatter(Y(:,1),Y(:,2),idxsel,'krbmg','o+*xs',7,'off')
        legend hide
        % spmplot(Y,,[],'box');
        detsol=[Typesolution num2str(i)  ': k=' num2str(Bestsols{i,1}) ' c=' num2str(Bestsols{i,2})];
        bestsol=[' Best for c=[' strtrim(num2str(min(Bestsols{i,3}))) '-' num2str(max(Bestsols{i,3})) ']'];
        Bestsolc=[Bestsols{i, 3} Bestsols{i,4}];
        stabsol=[' Stable for c=[' strtrim(num2str(min(Bestsolc))) '-' num2str(max(Bestsolc)) ']'];
        title([detsol bestsol stabsol ' Sol:' Bestsols{i,5}],'FontSize',FontSize)
        title(detsol,'FontSize',FontSize)
        
        text(0.35,0.95,bestsol,'Units','Normalized','FontSize',FontSize)
        text(0.35,0.85,stabsol,'Units','Normalized','FontSize',FontSize)
    end
    
    
end

prin=0;
if prin==1
    % print to postscript
    print -depsc figs\MIXMIXbestsolHEN.eps
end

%% Figure 11: car-bike plot
carbikeplot(outMIXMIX)
if prin==1
    % print to postscript
    print -depsc figs\carbikeHEN.eps
end