%% Simulation study to check the number of spurios solutions
% PRevious file was mar016 and apr016rev

clear
n=150;
v=6;
ktrue=3;
maxk=5;
alpha=0;

cc=[1 2 4 8 16 32 64 128];
ticklab={'c=1' 'c=2', 'c=4', 'c=8', 'c=16', ...
    'c=32' 'c=64' 'c=128'};

% Uncomment the two lines below if you wish to see result of
% misclassification just when c=10^10

cc=10^10;
ticklab={'c10to10'};

% nsamp
nsamp=1000;

nsimul=100;



ctrue=8;
NumberOfBestSolutions=7;

BarOmega=0.01:0.01:0.2;
nomega=length(BarOmega);
ARIMIXMIX=zeros(nsimul,3,nomega);
ARIMIXCLA=ARIMIXMIX;
ARICLACLA=ARIMIXMIX;
MIRCLACLA=ARIMIXMIX;
MIRMIXMIX=ARIMIXMIX;
MIRMIXCLA=ARIMIXMIX;

% Same matrices but referred to FowlkesMallowsIndex
ARIMIXMIXfm=ARIMIXMIX;
ARIMIXCLAfm=ARIMIXMIX;
ARICLACLAfm=ARIMIXMIX;

%% Run the simulation study

rng(1)
for kbaromega=1:nomega
    disp(['BarOmega=' num2str(BarOmega(kbaromega))])
    for jj=1:nsimul
        
        IC=tclustIC(Y,'nsamp',nsamp,'cleanpool',0,'msg',0);
        
        %%%%%%%%%%%%%%%%%%%%%%%% PART REFERRED TO THE ARI INDEX
        % ARI INDEX
        ICsol=tclustICsol(IC,'NumberOfBestSolutions',NumberOfBestSolutions,'plots',0,'Rand',1);
        
        %MIXMIX
        % Exclude spurios solutions
        seltrue=strcmp(ICsol.MIXMIXbs(:,5),'true');
        MIXMIXbsIDX=ICsol.MIXMIXbsIDX(:,seltrue);
        % MIXMIXbs=ICsol.MIXMIXbs(seltrue,:);
        ariMIXMIX=zeros(3,1);
        mirMIXMIX=ariMIXMIX;
        for j=1:3
            if j<=size(MIXMIXbsIDX,2)
                [ARI,~,MIR]=RandIndexFS(id,MIXMIXbsIDX(:,j));
                ariMIXMIX(j)=ARI;
                mirMIXMIX(j)=MIR;
            else
                ariMIXMIX(j)=ariMIXMIX(j-1);
                mirMIXMIX(j)=mirMIXMIX(j-1);
            end
            
        end
        ARIMIXMIX(jj,:,kbaromega)=[ariMIXMIX(1) max(ariMIXMIX(1:2)) max(ariMIXMIX(1:3))];
        MIRMIXMIX(jj,:,kbaromega)=[mirMIXMIX(1) min(mirMIXMIX(1:2)) min(mirMIXMIX(1:3))];
        
        %MIXCLA
        % Exclude spurios solutions
        seltrue=strcmp(ICsol.MIXCLAbs(:,5),'true');
        MIXCLAbsIDX=ICsol.MIXCLAbsIDX(:,seltrue);
        
        ariMIXCLA=zeros(3,1);
        mirMIXCLA=ariMIXCLA;
        for j=1:3
            if j<=size(MIXCLAbsIDX,2)
                
                [ARI,~,MIR]=RandIndexFS(id,MIXCLAbsIDX(:,j));
                ariMIXCLA(j)=ARI;
                mirMIXCLA(j)=MIR;
            else
                ariMIXCLA(j)=ariMIXCLA(j-1);
                mirMIXCLA(j)=mirMIXCLA(j-1);
            end
        end
        ARIMIXCLA(jj,:,kbaromega)=[ariMIXCLA(1) max(ariMIXCLA(1:2)) max(ariMIXCLA(1:3))];
        MIRMIXCLA(jj,:,kbaromega)=[mirMIXCLA(1) min(mirMIXCLA(1:2)) min(mirMIXCLA(1:3))];
        
        
        %CLACLA
        % Exclude spurios solutions
        seltrue=strcmp(ICsol.CLACLAbs(:,5),'true');
        CLACLAbsIDX=ICsol.CLACLAbsIDX(:,seltrue);
        ariCLACLA=zeros(3,1);
        mirCLACLA=ariCLACLA;
        for j=1:3
            if j<=size(CLACLAbsIDX,2)
                [ARI,~,MIR]=RandIndexFS(id,CLACLAbsIDX(:,j));
                ariCLACLA(j)=ARI;
                mirCLACLA(j)=MIR;
                
            else
                ariCLACLA(j)=ariCLACLA(j-1);
                mirCLACLA(j)=mirCLACLA(j-1);
            end
        end
        ARICLACLA(jj,:,kbaromega)=[ariCLACLA(1) max(ariCLACLA(1:2)) max(ariCLACLA(1:3))];
        MIRCLACLA(jj,:,kbaromega)=[mirCLACLA(1) min(mirCLACLA(1:2)) min(mirCLACLA(1:3))];
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %%%%%%%%%%%%%%%%% PART BELOW IS REFERRED TO FM INDEX
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        ICsol=tclustICsol(IC,'NumberOfBestSolutions',NumberOfBestSolutions,'plots',0,'Rand',0);
        
        
        %MIXMIX
        % Exclude spurios solutions
        seltrue=strcmp(ICsol.MIXMIXbs(:,5),'true');
        MIXMIXbsIDX=ICsol.MIXMIXbsIDX(:,seltrue);
        % MIXMIXbs=ICsol.MIXMIXbs(seltrue,:);
        ariMIXMIX=zeros(3,1);
        for j=1:3
            if j<=size(MIXMIXbsIDX,2)
                ariMIXMIX(j)=FowlkesMallowsIndex(id,MIXMIXbsIDX(:,j));
            else
                ariMIXMIX(j)=ariMIXMIX(j-1);
            end
            
        end
        ARIMIXMIXfm(jj,:,kbaromega)=[ariMIXMIX(1) max(ariMIXMIX(1:2)) max(ariMIXMIX(1:3))];
        
        %MIXCLA
        % Exclude spurios solutions
        seltrue=strcmp(ICsol.MIXCLAbs(:,5),'true');
        MIXCLAbsIDX=ICsol.MIXCLAbsIDX(:,seltrue);
        
        ariMIXCLA=zeros(3,1);
        for j=1:3
            if j<=size(MIXCLAbsIDX,2)
                ariMIXCLA(j)=FowlkesMallowsIndex(id,MIXCLAbsIDX(:,j));
                
            else
                ariMIXCLA(j)=ariMIXCLA(j-1);
            end
        end
        ARIMIXCLAfm(jj,:,kbaromega)=[ariMIXCLA(1) max(ariMIXCLA(1:2)) max(ariMIXCLA(1:3))];
        
        
        %CLACLA
        % Exclude spurios solutions
        seltrue=strcmp(ICsol.CLACLAbs(:,5),'true');
        CLACLAbsIDX=ICsol.CLACLAbsIDX(:,seltrue);
        ariCLACLA=zeros(3,1);
        for j=1:3
            if j<=size(CLACLAbsIDX,2)
                ariCLACLA(j)=FowlkesMallowsIndex(id,CLACLAbsIDX(:,j));
                
            else
                ariCLACLA(j)=ariCLACLA(j-1);
            end
        end
        ARICLACLAfm(jj,:,kbaromega)=[ariCLACLA(1) max(ariCLACLA(1:2)) max(ariCLACLA(1:3))];
        
    end
end

kk=IC.kk;
%% Plot final results

Color='rkb';    
LineStyle={'--';':';'-.';'-'};
LineWidth=3;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ARI INDEXES

% If Rand =1 it is possible to see monitoring of the ARI
Rand=1;
% If Rand =1 and MIR =1 it is possible to monitor the Miekin index.
MIR=0;
if Rand==1
    if MIR==1
        CLACLAr=squeeze(mean(MIRCLACLA,1))';
        MIXMIXr=squeeze(mean(MIRMIXMIX,1))';
        MIXCLAr=squeeze(mean(MIRMIXCLA,1))';
        
    else
        CLACLAr=squeeze(mean(ARICLACLA,1))';
        MIXMIXr=squeeze(mean(ARIMIXMIX,1))';
        MIXCLAr=squeeze(mean(ARIMIXCLA,1))';
    end
    
else
    CLACLAr=squeeze(mean(ARICLACLAfm,1))';
    MIXMIXr=squeeze(mean(ARIMIXMIXfm,1))';
    MIXCLAr=squeeze(mean(ARIMIXCLAfm,1))';
end

subplot(1,3,1)
j=1;
hold('on')
plot(BarOmega',MIXMIXr(:,j) ,'LineWidth',LineWidth,'LineStyle',LineStyle{1},'Color',Color(1));
plot(BarOmega',MIXCLAr(:,j) ,'LineWidth',LineWidth,'LineStyle',LineStyle{2},'Color',Color(2));
plot(BarOmega',CLACLAr(:,j) ,'LineWidth',LineWidth,'LineStyle',LineStyle{3},'Color',Color(3));

xlabel('Average overlap')
if Rand==1
    if MIR==1
        ylabel('Mirkin index')
    else
        ylabel('ARI index')
    end
else
    ylabel('AFM index')
end
title('Best solution')
subplot(1,3,2)
j=2;
hold('on')
plot(BarOmega',MIXMIXr(:,j) ,'LineWidth',LineWidth,'LineStyle',LineStyle{1},'Color',Color(1));
plot(BarOmega',MIXCLAr(:,j) ,'LineWidth',LineWidth,'LineStyle',LineStyle{2},'Color',Color(2));
plot(BarOmega',CLACLAr(:,j) ,'LineWidth',LineWidth,'LineStyle',LineStyle{3},'Color',Color(3));
xlabel('Average overlap')
title('First two solutions')

subplot(1,3,3)
j=3;
hold('on')
plot(BarOmega',MIXMIXr(:,j) ,'LineWidth',LineWidth,'LineStyle',LineStyle{1},'Color',Color(1));
plot(BarOmega',MIXCLAr(:,j) ,'LineWidth',LineWidth,'LineStyle',LineStyle{2},'Color',Color(2));
plot(BarOmega',CLACLAr(:,j) ,'LineWidth',LineWidth,'LineStyle',LineStyle{3},'Color',Color(3));
xlabel('Average overlap')
title('First three solutions')

legend({'MIXMIX' 'MIXCLA' 'CLACLA'})

%% save part

clearvars -except ARICLACLAfm ARIMIXMIXfm ARIMIXCLAfm MIRCLACLA MIRMIXMIX MIRMIXCLA ARICLACLA ARIMIXMIX ARIMIXCLA n v nsamp cc kk BarOmega MIXMIXr MIXCLAr CLACLAr ktrue ctrue NumberOfBestSolutions savestring


savestring = ['save(''WSSimStudy\n' num2str(n) 'v' num2str(v) 'nsamp' num2str(nsamp) 'k' num2str(ktrue) 'c' num2str(ctrue) '.mat' ''')'];
% eval(savestring)



%% Plot
% figure
% subplot(2,2,1)
% gscatter(Y(:,1),Y(:,2),id)
% title('true')
%
% ICstring='CLACLA';
% ICstring='MIXMIX';
% ICstring='MIXCLA';
% IDX=eval([ICstring 'bsIDX']);
% ARI=eval(['ari' ICstring]);
% for j=1:3
%     subplot(2,2,j+1)
%     if j<=size(IDX,2)
%         gscatter(Y(:,1),Y(:,2),IDX(:,j))
%         title(['Sol' num2str(j) ' ARI=' num2str(ARI(j))])
%     end
% end
% %%
% for j=1:3
%     subplot(2,2,j+1)
%     if j<=size(CLACLAbsIDX,2)
%         gscatter(Y(:,1),Y(:,2),CLACLAbsIDX(:,j))
%         title(['Sol' num2str(j) ' ARI=' num2str(ariCLACLA(j))])
%     end
% end
% %%
% spmplot(Y,id)
% spmplot(Y,CLACLAbsIDX(:,3))
